<?php
/*
			REQUIREMENTS
- Put 		ip-to-country-i.php into Smf's root directory (where index.php located)
- Be sure	SSI.php (database informations) and
			ip-to-country.csv (IP database) in same directory
*/

if (file_exists(dirname(__FILE__) . '/SSI.php'))
  require_once(dirname(__FILE__) . '/SSI.php');
else
  die('Error: Cannot install - please verify you put this in the same place as SMF\'s index.php.');

$file = $_SERVER["SCRIPT_NAME"];						// Get script URL (to redirect itself)
$handle = fopen("ip-to-country.csv", "r");				// Handle of ip-to-country.csv
$step = isset($_GET['step']) ? (int) $_GET['step'] : 0;	// Get current row step from URL, 0 if not shown
$redirect = false;		// if not all rows inserted this variable becomes true, and page redirect itself to next step
$processed = 10000;		// Number of records will be inserted per redirect, to prevent 500 internal server error (execution time)
						// You can set this 1000000 (1 million) if you wont have that error.
$added = 0;				// Checking variable, are all rows inserted?
$i = 0;					// loop variable
						// Prints beginning of informative results
echo '
	<html>
	<head>
		<title>IP Database Installer</title>
	</head>
	<body>
		<a>';

// if this is a first step of installation (then check the database tables)
if ($step == 0)
{
	// Create IP table if not exist
	$result = db_query("
			CREATE TABLE IF NOT EXISTS {$db_prefix}ip_lookup (
				`ipFrom` INT( 15 ) UNSIGNED NOT NULL DEFAULT '0',
				`ipTo` INT( 15 ) UNSIGNED NOT NULL DEFAULT '0',
				`country2` VARCHAR( 2 ) NOT NULL ,
				`country3` VARCHAR( 3 ) NOT NULL ,
				`country` VARCHAR( 60 ) NOT NULL
			)", __FILE__, __LINE__);
	if ($result === false)
		die("Table creation failed: " . mysql_error().__LINE__.__FILE__);
	else
		echo 'Table creation success.<br>';

	// And clear previous content of IP table if already exist
	$result = db_query("
			TRUNCATE TABLE {$db_prefix}ip_lookup", __FILE__, __LINE__);
	if ($result === false)
		die("Table pruning failed: " . mysql_error().__LINE__.__FILE__);
	else
		echo 'Table pruning success.<br>';
}

// Loop through each rows of csv file
while ($data = fgetcsv($handle, 1000, ","))
{
	$i++;
	if ($i <= $step)		// ignore the current row if alredy inserted (in previous redirects)
		continue;
	// fresh rows, insert into database
	$result = db_query("
            INSERT INTO {$db_prefix}ip_lookup(`ipFrom`, `ipTo`, `country2`, `country3`, `country`)
			VALUES('".$data[0]."', '".$data[1]."', '".$data[2]."', '".$data[3]."', '". addslashes($data[4]) ."')
			", __FILE__, __LINE__);
	if ($result === false)
		die("Row insertion failed: " . mysql_error().__LINE__.__FILE__);
	$added++;					// increase added rows
	if ($added >= $processed)	// and check is it reached the max limit per redirect
	{
		$redirect = true;		// redirect the page if max limit happens
		break;
	}
}

fclose ($handle);				// Release csv file

if ($redirect == true)			// Print information
{
	echo $i . ' rows inserted into database.<br>
		Continuing...
		</a>
	</body>
	</html>';
	header('Refresh: 0; URL=' . $file . '?step=' . $i);
}
else
	echo 'It is done.<br>' . $i . ' rows added in total.
		</a>
	</body>
	</html>';

?>